diff --git a/res/res_fax.c b/res/res_fax.c
index 823d560d9b..8120aa0f22 100644
--- a/res/res_fax.c
+++ b/res/res_fax.c
@@ -1097,6 +1097,8 @@ static void destroy_session(void *session)
 {
 	struct ast_fax_session *s = session;
 
+	ast_log(LOG_ERROR, "Destroying fax session '%p'\n", s);
+
 	if (s->tech) {
 		fax_session_release(s, NULL);
 		if (s->tech_pvt) {
@@ -1151,6 +1153,8 @@ static struct ast_fax_session *fax_session_reserve(struct ast_fax_session_detail
 		return NULL;
 	}
 
+	ast_log(LOG_ERROR, "Reserved fax session '%p'\n", s);
+
 	s->state = AST_FAX_STATE_INACTIVE;
 	s->details = details;
 	ao2_ref(s->details, 1);
@@ -1235,6 +1239,8 @@ static struct ast_fax_session *fax_session_new(struct ast_fax_session_details *d
 		return NULL;
 	}
 
+	ast_log(LOG_ERROR, "Allocated fax session '%p'\n", s);
+
 	ast_atomic_fetchadd_int(&faxregistry.active_sessions, 1);
 	s->state = AST_FAX_STATE_UNINITIALIZED;
 
@@ -2816,6 +2822,7 @@ static int sendfax_exec(struct ast_channel *chan, const char *data)
 static void destroy_v21_sessions(struct fax_gateway *gateway)
 {
 	if (gateway->chan_v21_session) {
+		ast_log(LOG_ERROR, "Removing chan v21 fax session '%p'\n", gateway->chan_v21_session);
 		ao2_unlink(faxregistry.container, gateway->chan_v21_session);
 
 		ao2_ref(gateway->chan_v21_session, -1);
@@ -2823,6 +2830,7 @@ static void destroy_v21_sessions(struct fax_gateway *gateway)
 	}
 
 	if (gateway->peer_v21_session) {
+		ast_log(LOG_ERROR, "Removing peer v21 fax session '%p'\n", gateway->peer_v21_session);
 		ao2_unlink(faxregistry.container, gateway->peer_v21_session);
 
 		ao2_ref(gateway->peer_v21_session, -1);
@@ -2838,6 +2846,7 @@ static void destroy_gateway(void *data)
 	destroy_v21_sessions(gateway);
 
 	if (gateway->s) {
+		ast_log(LOG_ERROR, "Removing gateway fax session '%p'\n", gateway->s);
 		fax_session_release(gateway->s, gateway->token);
 		gateway->token = NULL;
 
@@ -2929,6 +2938,7 @@ static int fax_gateway_start(struct fax_gateway *gateway, struct ast_fax_session
 	/* release the reference for the reserved session and replace it with
 	 * the real session */
 	if (gateway->s) {
+		ast_log(LOG_ERROR, "Dropping reference on reserved fax session '%p' to replace it with '%p'\n", gateway->s, s);
 		ao2_ref(gateway->s, -1);
 	}
 	gateway->s = s;
@@ -3433,6 +3443,7 @@ static struct ast_frame *fax_gateway_framehook(struct ast_channel *chan, struct
 		ast_channel_unlock(peer);
 
 		gateway->bridged = 1;
+		ast_log(LOG_ERROR, "Before allocating peer v21 fax session: '%p'\n", gateway->peer_v21_session);
 		if (!(gateway->peer_v21_session = fax_v21_session_new(peer))) {
 			ast_log(LOG_ERROR, "Can't create V21 session on chan %s for T.38 gateway session\n", ast_channel_name(peer));
 			ast_framehook_detach(chan, gateway->framehook);
